'3s Lipo berweachung   version 2.0

$regfile = "attiny25.dat"
$crystal = 1000000                                          'Fuse ckdiv8 setzen
$hwstack = 32
$swstack = 8
$framesize = 24

'Konfiguration der I/O-Portss
 Config Portb.0 = Output                                    ' Led rot an pin5
 Config Portb.1 = Output                                    ' Led grn an pin6
 Config Portb.3 = Output                                    ' Signalgeber an pin2

 Config Adc = Single , Prescaler = Auto , Reference = Internal_2.56_nocap
      'a/d Wandler mit Spannungsteiler 100k minus :680k plus
 Start Adc                                                  ' a/d Wandler einschalten


 Dim W As Word                                              ' Spannung messen
 Dim A As Word                                              ' Blinkfrequence
 Dim B As Word                                              ' Blinkfrequence
 Dim Z1 As Byte                                             ' Zaehler 1
 Dim Pulses As Word , Periods As Word                       ' Signalgeber


 '***** namen den ports zuweisen *****

 Signalgeber Alias Portb.3
 Led_rot Alias Portb . 0
 Led_gruen Alias Portb . 1

 '***** variablem werte zuweisen *****
 A = 500 : B = 500                                          'variablem fr die blink-frequnce
 Pulses = 2000 : Periods = 25                               'variablem fr die ton ausgabe


 Led_rot = 1 : Led_gruen = 1                                'beide Led's aus



 Do

Messen:

   W = Getadc(2)                                            ' einlesen der Akkuspannung mit spannungsteiler

 If W < 530 Then                                            'Spannungs kleiner als ca. 9.9 Volt = Led rot blinkt und signalgeber ertont
      Gosub Blinken_ton

    Elseif W < 570 Then                                     'Spannungs zwisachen 10 und 10,7 Volt = Led rot blinkt
      Gosub Blinken

    Else                                                    ' Spannung groesser als ca. 10,8 Volt  = Led grn an
      Led_gruen = 0                                         'Led grn an
      Led_rot = 1                                           'Led rot aus
      Z1 = 0                                                ' Zhler auf 0 setzen


 End If


 Loop


End

 Blinken:


    Led_rot = 0
    Led_gruen = 1
   Waitms A


    Led_rot = 1

   Waitms B

Return

Blinken_ton:


    Led_rot = 0
    Led_gruen = 1
   Waitms A

  Sound Signalgeber , Pulses , Periods

   Waitms B

  Z1 = Z1 + 1
  If Z1 = 20 Then
  Goto Dauerarlarm

  End If

Return

 Dauerarlarm:
 Do                                                         ' Endlosschleife der Sender muss ausgeschaltet werden


     Sound Signalgeber , Pulses , Periods

 Loop